Getting Started with JavaScript Scheduler

This guide explains how to create a JavaScript Scheduler component and configure its core features in a JavaScript application.

Ready to streamline your Syncfusion® JavaScript development? Discover the full potential of Syncfusion® JavaScript controls with Syncfusion® AI Coding Assistant. Effortlessly integrate, configure, and enhance your projects with intelligent, context-aware code suggestions, streamlined setups, and real-time insights—all seamlessly integrated into your preferred AI-powered IDEs like VS Code, Cursor, Syncfusion® CodeStudio and more. Explore Syncfusion® AI Coding Assistant

Prerequisites

Before getting started, ensure the following requirements are met:

Requirement Notes
Modern web browser Chrome, Firefox, Edge, or Safari — latest version recommended
Code editor Visual Studio Code is recommended
Local HTTP server Required to serve the application. Opening HTML files directly via file:// may block script loading in some browsers. VS Code Live Server extension is recommended

Dependencies

The Scheduler component requires the following dependencies:

|-- @syncfusion/ej2-schedule
    |-- @syncfusion/ej2-base
    |-- @syncfusion/ej2-buttons
    |-- @syncfusion/ej2-calendars
    |-- @syncfusion/ej2-data
    |-- @syncfusion/ej2-dropdowns
    |-- @syncfusion/ej2-excel-export
    |-- @syncfusion/ej2-inputs
    |-- @syncfusion/ej2-lists
    |-- @syncfusion/ej2-popups
    |-- @syncfusion/ej2-navigations

Setup for local environment

Follow these steps to set up your local development environment:

Step 1: Create a root folder my-app for your application.

Step 2: Create a my-app/resources folder to store local scripts and style files.

Step 3: Create my-app/index.js and my-app/index.html files for initializing the Essential® JS 2 Scheduler control.

Adding Syncfusion® resources

The Essential® JS 2 Scheduler control can be initialized using either of the following methods:

  • Using local scripts and styles.
  • Using CDN links for scripts and styles.

Using local scripts and styles

You can obtain global scripts and styles from the Essential Studio® JavaScript (Essential® JS 2) build installation location.

After installing the Essential® JS 2 product build, copy the Scheduler and its dependency scripts and style files into the resources/scripts and resources/styles folders respectively.

Reference the Scheduler’s script and style files from the following locations:

Syntax:

Script: **(installed location)**/Syncfusion/Essential Studio/{RELEASE_VERSION}/Essential JS 2/{PACKAGE_NAME}/dist/global/{PACKAGE_NAME}.min.js

Styles: **(installed location)**/Syncfusion/Essential Studio/{RELEASE_VERSION}/Essential JS 2/{PACKAGE_NAME}/styles/bootstrap5.3.css

Example:

Script: C:/Program Files (x86)/Syncfusion/Essential Studio/15.4.30/Essential JS 2/ej2-schedule/dist/global/ej2-schedule.min.js

Styles: C:/Program Files (x86)/Syncfusion/Essential Studio/15.4.30/Essential JS 2/ej2-schedule/styles/bootstrap5.3.css

After copying the files, reference the Scheduler’s scripts and styles in the index.html file.
The following HTML code example shows the Scheduler’s dependencies:

<!DOCTYPE html>
  <html xmlns="https://www.w3.org/1999/xhtml">
       <head>
            <title>Essential JS 2 Scheduler</title>
            <!-- Essential JS 2 Scheduler's dependent material theme -->
            <link href="resources/base/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="resources/buttons/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="resources/calendars/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="resources/dropdowns/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="resources/inputs/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="resources/splitbuttons/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="resources/lists/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="resources/popups/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="resources/navigations/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <!-- Essential JS 2 Scheduler's material theme -->
            <link href="resources/schedule/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>

            <!-- Essential JS 2 Scheduler's dependent scripts -->
            <script src="resources/scripts/ej2-base.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-inputs.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-calendars.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-file-utils.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-buttons.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-lists.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-data.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-navigations.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-popups.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-dropdowns.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-splitbuttons.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-compression.min.js" type="text/javascript"></script>
            <script src="resources/scripts/ej2-excel-export.min.js" type="text/javascript"></script>
            <!-- Essential JS 2 Scheduler's global script -->
            <script src="resources/scripts/ej2-schedule.min.js" type="text/javascript"></script>
       </head>
       <body>
       </body>
  </html>

Using CDN links, you can directly reference the Scheduler’s script and styles in the index.html file.

Reference the Scheduler’s CDN links as shown below:

Syntax:

Script: https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/{PACKAGE_NAME}/dist/global/{PACKAGE_NAME}.min.js

Styles: https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/{PACKAGE_NAME}/styles/bootstrap5.3.css

Example:

Script: https://cdn.syncfusion.com/ej2/32.1.19/ej2-schedule/dist/global/ej2-schedule.min.js

Styles: https://cdn.syncfusion.com/ej2/32.1.19/ej2-schedule/styles/bootstrap5.3.css

The following HTML code example shows the Scheduler dependencies using ej2-schedule.min.js:

<!DOCTYPE html>
  <html xmlns="https://www.w3.org/1999/xhtml">
       <head>
            <title>Essential JS 2 Scheduler</title>
            <!-- Essential JS 2 Scheduler's dependent material theme -->
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-base/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-calendars/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-dropdowns/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-inputs/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-splitbuttons/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <!-- Essential JS 2 Scheduler's material theme -->
            <link href="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-schedule/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>

            <!-- Essential JS 2 Scheduler's dependent script -->
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-base/dist/global/ej2-base.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-inputs/dist/global/ej2-inputs.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-calendars/dist/global/ej2-calendars.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-file-utils/dist/global/ej2-file-utils.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-buttons/dist/global/ej2-buttons.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-lists/dist/global/ej2-lists.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-data/dist/global/ej2-data.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-navigations/dist/global/ej2-navigations.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-popups/dist/global/ej2-popups.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-dropdowns/dist/global/ej2-dropdowns.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-splitbuttons/dist/global/ej2-splitbuttons.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-compression/dist/global/ej2-compression.min.js" type="text/javascript"></script>
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-excel-export/dist/global/ej2-excel-export.min.js" type="text/javascript"></script>
            <!-- Essential JS 2 Scheduler's global script -->
            <script src="https://cdn.syncfusion.com/ej2/{RELEASE_VERSION}/ej2-schedule/dist/global/ej2-schedule.min.js" type="text/javascript"></script>
       </head>
       <body>
           <!-- Add the HTML <div> element for scheduler  -->
             <div id="Schedule"></div>
             <script src="index.js" type="text/javascript"></script>
       </body>
  </html>

Place the following Scheduler code in the index.js file:

ej.schedule.Schedule.Inject(ej.schedule.Day, ej.schedule.Week, ej.schedule.WorkWeek, ej.schedule.Month, ej.schedule.Agenda);
var scheduleObj = new ej.schedule.Schedule();
scheduleObj.appendTo('#Schedule');

Initialize the Scheduler

Add a div element for the Scheduler control in index.html and reference the index.js file.

In this example, ej2.min.js is used, which includes all Essential® JS 2 components and their dependencies.

<!DOCTYPE html>
  <html xmlns="https://www.w3.org/1999/xhtml">
       <head>
            <title>Essential JS 2 Scheduler</title>
            <!-- Essential JS 2 Scheduler's dependent material theme -->
            <link href="https://cdn.syncfusion.com/ej2/ej2-base/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/ej2-calendars/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/ej2-dropdowns/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/ej2-inputs/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/ej2-splitbuttons/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <link href="https://cdn.syncfusion.com/ej2/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>
            <!-- Essential JS 2 Scheduler's material theme -->
            <link href="https://cdn.syncfusion.com/ej2/ej2-schedule/styles/bootstrap5.3.css" rel="stylesheet" type="text/css"/>

            <!-- Essential JS 2 all script -->
            <script src="https://cdn.syncfusion.com/ej2/dist/ej2.min.js" type="text/javascript"></script>
       </head>
       <body>
           <!-- Add the HTML <div> element for scheduler  -->
             <div id="Schedule"></div>
             <script src="index.js" type="text/javascript"></script>
       </body>
  </html>

Place the following Scheduler code in the index.js file:

var scheduleObj = new ej.schedule.Schedule();
scheduleObj.appendTo('#Schedule');

Populating appointments

To populate the empty Scheduler with appointments, define local JSON data or remote data through the dataSource property within the eventSettings option. The start and end time fields are mandatory for appointments. The following example demonstrates an appointment defined with default fields: Id, Subject, StartTime, and EndTime.

var scheduleObj = new ej.schedule.Schedule({
    height: '550px',
    selectedDate: new Date(2018, 1, 15),
    eventSettings: {
        dataSource: [{
            Id: 1,
            Subject: 'Meeting',
            StartTime: new Date(2018, 1, 15, 10, 0),
            EndTime: new Date(2018, 1, 15, 12, 30)
        }]
    }
});
scheduleObj.appendTo('#Schedule');

You can also use custom field names by mapping them appropriately within the fields property:

var data = [{
    Id: 2,
    EventName: 'Meeting',
    StartTime: new Date(2018, 1, 15, 10, 0),
    EndTime: new Date(2018, 1, 15, 12, 30),
    IsAllDay: false,
    Status: 'Completed',
    Priority: 'High'
}];
var scheduleObj = new ej.schedule.Schedule({
    height: '550px',
    selectedDate: new Date(2018, 1, 15),
    eventSettings: {
        dataSource: data,
        fields: {
            id: 'Id',
            subject: { name: 'EventName' },
            isAllDay: { name: 'IsAllDay' },
            startTime: { name: 'StartTime' },
            endTime: { name: 'EndTime' }
        }
    }
});
scheduleObj.appendTo('#Schedule');

The other fields available in Scheduler can be referred from here.

Setting date

By default, the Scheduler displays the current system date. To change the Scheduler’s current date, set the selectedDate property to a specific date.

var scheduleObj = new ej.schedule.Schedule({
    height: '550px',
    selectedDate: new Date(2018, 1, 15)
});
scheduleObj.appendTo('#Schedule');

Setting view

The Scheduler displays the Week view by default. To change the current view, set the currentView property to one of the following view names:

  • Day
  • Week
  • WorkWeek
  • Month
  • Year
  • Agenda
  • MonthAgenda
  • TimelineDay
  • TimelineWeek
  • TimelineWorkWeek
  • TimelineMonth
  • TimelineYear
var scheduleObj = new ej.schedule.Schedule({
    height: '550px',
    selectedDate: new Date(2018, 1, 15),
    currentView: 'Month'
});
scheduleObj.appendTo('#Schedule');

Individual view customization

Each Scheduler view can be customized individually with its own options, such as setting different start and end hours for Week and Work Week views or hiding weekend days in the Month view only. This is achieved by defining the views property as an array of objects, where each object represents the customization for an individual view.

Now, run the application in the browser using the following command:

npm start

The output will display the Scheduler with the specified view configuration.

ej.schedule.Schedule.Inject(ej.schedule.Week, ej.schedule.WorkWeek, ej.schedule.Month);

var scheduleObj = new ej.schedule.Schedule({
    width: '100%',
    height: '550px',
    selectedDate: new Date(2018, 1, 15),
    views: [{ option: 'Week', startHour: '07:00', endHour: '15:00'},
            { option: 'WorkWeek', startHour: '10:00', endHour: '18:00'}, 
            { option: 'Month' , showWeekend: false }],
    eventSettings: { dataSource: scheduleData }
});
scheduleObj.appendTo('#Schedule');
<!DOCTYPE html><html lang="en"><head>
    <title>Schedule Typescript Component</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Typescript Schedule Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-calendars/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-dropdowns/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet"> 
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-schedule/styles/bootstrap5.3.css" rel="stylesheet">
    
    

<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
        <div id="container">
                <div id="Schedule"></div>
        </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
var scheduleData = [
{
        Id: 1,
        Subject: 'Explosion of Betelgeuse Star',
        StartTime: new Date(2018, 1, 11, 9, 30),
        EndTime: new Date(2018, 1, 11, 11, 0),
        CategoryColor: '#1aaa55'
}, {
        Id: 2,
        Subject: 'Thule Air Crash Report',
        StartTime: new Date(2018, 1, 12, 12, 0),
        EndTime: new Date(2018, 1, 12, 14, 0),
        CategoryColor: '#357cd2'
}, {
        Id: 3,
        Subject: 'Blue Moon Eclipse',
        StartTime: new Date(2018, 1, 13, 9, 30),
        EndTime: new Date(2018, 1, 13, 11, 0),
        CategoryColor: '#7fa900'
}, {
        Id: 4,
        Subject: 'Meteor Showers in 2018',
        StartTime: new Date(2018, 1, 14, 13, 0),
        EndTime: new Date(2018, 1, 14, 14, 30),
        CategoryColor: '#ea7a57'
}, {
        Id: 5,
        Subject: 'Milky Way as Melting pot',
        StartTime: new Date(2018, 1, 15, 12, 0),
        EndTime: new Date(2018, 1, 15, 14, 0),
        CategoryColor: '#00bdae'
}, {
        Id: 6,
        Subject: 'Mysteries of Bermuda Triangle',
        StartTime: new Date(2018, 1, 15, 9, 30),
        EndTime: new Date(2018, 1, 15, 11, 0),
        CategoryColor: '#f57f17'
}, {
        Id: 7,
        Subject: 'Glaciers and Snowflakes',
        StartTime: new Date(2018, 1, 16, 11, 0),
        EndTime: new Date(2018, 1, 16, 12, 30),
        CategoryColor: '#1aaa55'
}, {
        Id: 8,
        Subject: 'Life on Mars',
        StartTime: new Date(2018, 1, 17, 9, 0),
        EndTime: new Date(2018, 1, 17, 10, 0),
        CategoryColor: '#357cd2'
}, {
        Id: 9,
        Subject: 'Alien Civilization',
        StartTime: new Date(2018, 1, 19, 11, 0),
        EndTime: new Date(2018, 1, 19, 13, 0),
        CategoryColor: '#7fa900'
}, {
        Id: 10,
        Subject: 'Wildlife Galleries',
        StartTime: new Date(2018, 1, 21, 11, 0),
        EndTime: new Date(2018, 1, 21, 13, 0),
        CategoryColor: '#ea7a57'
}, {
        Id: 11,
        Subject: 'Best Photography 2018',
        StartTime: new Date(2018, 1, 22, 9, 30),
        EndTime: new Date(2018, 1, 22, 11, 0),
        CategoryColor: '#00bdae'
}, {
        Id: 12,
        Subject: 'Smarter Puppies',
        StartTime: new Date(2018, 1, 9, 10, 0),
        EndTime: new Date(2018, 1, 9, 11, 30),
        CategoryColor: '#f57f17'
}, {
        Id: 13,
        Subject: 'Myths of Andromeda Galaxy',
        StartTime: new Date(2018, 1, 7, 10, 30),
        EndTime: new Date(2018, 1, 7, 12, 30),
        CategoryColor: '#1aaa55'
}, {
        Id: 14,
        Subject: 'Aliens vs Humans',
        StartTime: new Date(2018, 1, 5, 10, 0),
        EndTime: new Date(2018, 1, 5, 11, 30),
        CategoryColor: '#357cd2'
}, {
        Id: 15,
        Subject: 'Facts of Humming Birds',
        StartTime: new Date(2018, 1, 20, 9, 30),
        EndTime: new Date(2018, 1, 20, 11, 0),
        CategoryColor: '#7fa900'
}, {
        Id: 16,
        Subject: 'Sky Gazers',
        StartTime: new Date(2018, 1, 23, 11, 0),
        EndTime: new Date(2018, 1, 23, 13, 0),
        CategoryColor: '#ea7a57'
}, {
        Id: 17,
        Subject: 'The Cycle of Seasons',
        StartTime: new Date(2018, 1, 12, 5, 30),
        EndTime: new Date(2018, 1, 12, 7, 30),
        CategoryColor: '#00bdae'
}, {
        Id: 18,
        Subject: 'Space Galaxies and Planets',
        StartTime: new Date(2018, 1, 12, 17, 0),
        EndTime: new Date(2018, 1, 12, 18, 30),
        CategoryColor: '#f57f17'
}, {
        Id: 19,
        Subject: 'Lifecycle of Bumblebee',
        StartTime: new Date(2018, 1, 15, 6, 0),
        EndTime: new Date(2018, 1, 15, 7, 30),
        CategoryColor: '#7fa900'
}, {
        Id: 20,
        Subject: 'Sky Gazers',
        StartTime: new Date(2018, 1, 15, 16, 0),
        EndTime: new Date(2018, 1, 15, 18, 0),
        CategoryColor: '#ea7a57'
}];

You can also explore the JavaScript Scheduler example to see how toolbar buttons interact with Scheduler functionalities.

Getting Started with Vue Scheduler

This article provides a step-by-step guide to creating a Vue 2 application using Vue-CLI and integrating the Vue Schedule component. It covers project setup, component installation, module injection, data binding, and basic customization.

Ready to streamline your Vue development? Discover the full potential of Vue components with Syncfusion® AI Coding Assistant. Effortlessly integrate, configure, and enhance your projects with intelligent, context-aware code suggestions, streamlined setups, and real-time insights—all seamlessly integrated into your preferred AI-powered IDEs like VS Code, Cursor, Syncfusion® CodeStudio and more. Explore Syncfusion® AI Coding Assistant

Check the following video to learn how to build a Vue Scheduler application:

Prerequisites

Requirement Version
Vue 2.6 or higher
Node.js 16.0.0 or above

Vue supported versions

Vue version Minimum Syncfusion Vue Schedule version
Vue v2.7 20.3.47 and above

Browser Support

Browser Supported versions
Chrome Latest
Firefox Latest
Opera Latest
Edge 13+
Internet Explorer (IE) 11+
Safari 9+
iOS Safari 9+
Android Browser / Chrome for Android 4.4+
Windows Mobile IE 11+

Note: This guide is for Vue 2. For Vue 3, refer to the Getting Started with Vue 3 guide.

Setting up the Vue 2 project

To generate a Vue 2 project using Vue-CLI, use the vue create command. Follow these steps to install Vue CLI and create a new project:

npm install -g @vue/cli
vue create quickstart
cd quickstart
npm run serve

or

yarn global add @vue/cli
vue create quickstart
cd quickstart
yarn run serve

When creating a new project, choose the option Default ([Vue 2] babel, eslint) from the menu.

Vue 2 project

Once the quickstart project is set up with default settings, proceed to add Syncfusion® components to the project.

Add Vue packages

Syncfusion® packages are available at npmjs.com. To use Vue components, install the required npm package.

This article uses the Vue Schedule component as an example. Install the @syncfusion/ej2-vue-schedule package by running the following command:

npm install @syncfusion/ej2-vue-schedule --save

or

yarn add @syncfusion/ej2-vue-schedule

The –save will instruct NPM to include the Scheduler package inside of the dependencies section of the package.json.

Import Syncfusion® CSS styles

Themes for Syncfusion® Schedule component can be applied using CSS files provided through npm theme packages. The following example uses the Tailwind 3 theme. For other available themes (Bootstrap, Material, Fluent, etc.), refer to the Themes documentation.

Install the Material 3 theme package using the following command:

npm install @syncfusion/ej2-material3-theme --save

Then add the following CSS reference to the src/App.vue file:

<style>
    @import '../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css';
</style>

Add Vue component

Follow the below steps to add the Vue Schedule component:

Import and register the Schedule component in the script section, and define the component in the template section of the src/App.vue file.

<template>
  <div id='app'>
    <ejs-schedule></ejs-schedule>
  </div>
</template>
<script>
import { ScheduleComponent } from '@syncfusion/ej2-vue-schedule';

export default {
  components: {
    'ejs-schedule': ScheduleComponent
  }
}
</script>

Module injection

The crucial step in creating a Schedule with specific views is to inject the required modules. Without module injection, only the default views will be available. The modules that are available with common Schedule basic functionality are as follows:

  • Day - Inject this module for displaying day view.
  • Week - Inject this module for displaying week view.
  • WorkWeek - Inject this module for displaying work week view.
  • Month - Inject this module for displaying month view.
  • Agenda - Inject this module for displaying agenda view.
  • MonthAgenda - Inject this module for displaying month agenda view.
  • Year - Inject this module for displaying year view.
  • TimelineViews - Inject this module for displaying timeline day, timeline week, and timeline work week views.
  • TimelineMonth - Inject this module for displaying timeline month view.
  • TimelineYear - Inject this module for displaying timeline year view.

These modules should be injected into the Schedule using the provide method within the app.vue file as shown below. Once injected, only the injected views will be loaded and displayed on the Schedule.

[src/app/app.vue]

<template>
  <div id='app'>
    <ejs-schedule ></ejs-schedule>
  </div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';

export default {
  components: {
    'ejs-schedule': ScheduleComponent
  },
  provide: {
    schedule: [Day, Week, WorkWeek, Month, Agenda]
  }
}
</script>

Run the project

To run the project, use the following command:

npm run serve

or

yarn run serve

The output will display the empty Scheduler.

Populating Appointments

To populate the empty Scheduler with appointments, define either local JSON data or remote data through the dataSource property available within the eventSettings option. To define any appointments, start and end time fields are mandatory.

Using Default Field Names:

In the following example, you can see the appointment defined with default fields such as Id, Subject, StartTime, and EndTime:

<template>
  <div id='app'>
      <ejs-schedule height='550px' :selectedDate='selectedDate' :eventSettings='eventSettings'></ejs-schedule>
  </div>
</template>
<script>
  import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
  export default {
      components: {
        'ejs-schedule': ScheduleComponent
      },
      data () {
        return {
          selectedDate: new Date(2018, 1, 15),
          eventSettings: {
            dataSource: [{
              Id: 1,
              Subject: 'Meeting',
              StartTime: new Date(2018, 1, 15, 10, 0),
              EndTime: new Date(2018, 1, 15, 12, 30)
            }]
          }
        }
      },
      provide: {
        schedule: [Day, Week, WorkWeek, Month, Agenda]
      }
  }
</script>

Using Custom Field Names:

If your data uses different field names, map the custom field names using the fields property as shown below:

<template>
  <div id='app'>
      <ejs-schedule height='550px' :selectedDate='selectedDate' :eventSettings='eventSettings'></ejs-schedule>
  </div>
</template>
<script>
  import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
  
  let data = [{
    Id: 2,
    EventName: 'Meeting',
    StartTime: new Date(2018, 1, 15, 10, 0),
    EndTime: new Date(2018, 1, 15, 12, 30),
    IsAllDay: false
  }];

  export default {
    components: {
      'ejs-schedule': ScheduleComponent
    },
    data () {
      return {
        selectedDate: new Date(2018, 1, 15),
        eventSettings: {
          dataSource: data,
          fields: {
            id: 'Id',
            subject: { name: 'EventName' },
            isAllDay: { name: 'IsAllDay' },
            startTime: { name: 'StartTime' },
            endTime: { name: 'EndTime' }
          }
        }
      }
    },
    provide: {
      schedule: [Day, Week, WorkWeek, Month, Agenda]
    }
  }
</script>

The other fields available in Scheduler can be referred from here.

Setting Date

By default, the Scheduler displays the system date as its current date. To change the Scheduler’s current date to a specific date, set the selectedDate property to a JavaScript Date object.

[src/app/app.vue]

<template>
  <div id='app'>
      <ejs-schedule height='550px' :selectedDate='selectedDate'></ejs-schedule>
  </div>
</template>
<script>
  import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';

  export default {
    components: {
      'ejs-schedule': ScheduleComponent
    },
    data (){
      return {
        selectedDate: new Date(2018, 1, 15)
      }
    },
    provide: {
      schedule: [Day, Week, WorkWeek, Month, Agenda]
    }
  }
</script>

Setting View

Scheduler displays week view by default. To change the current view, define the applicable view name to the currentView property. The applicable view names are:

  • Day
  • Week
  • WorkWeek
  • Month
  • Year
  • Agenda
  • MonthAgenda
  • TimelineDay
  • TimelineWeek
  • TimelineWorkWeek
  • TimelineMonth
  • TimelineYear
<template>
    <div id='app'>
        <ejs-schedule height='550px' :selectedDate='selectedDate' :currentView='currentView'>
        </ejs-schedule>
    </div>
</template>
<script>
  import { ScheduleComponent, Day, WorkWeek, Agenda, Month, Week } from '@syncfusion/ej2-vue-schedule';
  export default {
    components: {
      'ejs-schedule': ScheduleComponent
    },
    data () {
      return {
        selectedDate: new Date(2018, 1, 15),
        currentView: 'Month',
      }
    },
    provide: {
      schedule: [Day, WorkWeek, Agenda, Month, Week]
    }
  }
</script>

Individual View Customization

Each individual Scheduler view can be customized with its own options, such as setting different start and end hours on Week and Work Week views, or hiding weekend days on Month view alone. This is achieved by defining the views property as an array of objects, where each object represents an individual view with its customization options.

The output will display the Scheduler with the specified view configuration.

<template>
  <div id='app'>
    <ejs-schedule height='550px' width='100%' :selectedDate='selectedDate' :eventSettings='eventSettings'>
      <e-views>
        <e-view option='Week' startHour='07:00' endHour='15:00'></e-view>
        <e-view option='WorkWeek' startHour='10:00' endHour='18:00'></e-view>
        <e-view option='Month' showWeekend=false></e-view>
      </e-views>
    </ejs-schedule>
  </div>
</template>
<script>
import { scheduleData } from './datasource.js';
import { extend } from '@syncfusion/ej2-base';
import { ScheduleComponent, ViewsDirective, ViewDirective, WorkWeek, Month, Week } from '@syncfusion/ej2-vue-schedule';

export default {
  name: "App",
  components: {
    'ejs-schedule': ScheduleComponent,
    'e-view': ViewDirective,
    'e-views': ViewsDirective
  },
  data() {
    return {
      eventSettings: { dataSource: extend([], scheduleData, null, true) },
      selectedDate: new Date(2018, 1, 15)
    }
  },
  provide: {
    schedule: [WorkWeek, Month, Week]
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-calendars/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-vue-schedule/styles/material3.css';
</style>
define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.scheduleData = [
        {
            Id: 1,
            Subject: 'Conference',
            StartTime: new Date(2018, 1, 7, 10, 0),
            EndTime: new Date(2018, 1, 7, 11, 0),
            IsAllDay: false
        }, {
            Id: 2,
            Subject: 'Meeting - 1',
            StartTime: new Date(2018, 1, 15, 10, 0),
            EndTime: new Date(2018, 1, 16, 12, 30),
            IsAllDay: false
        }, {
            Id: 3,
            Subject: 'Paris',
            StartTime: new Date(2018, 1, 13, 12, 0),
            EndTime: new Date(2018, 1, 13, 12, 30),
            IsAllDay: false
        }, {
            Id: 4,
            Subject: 'Vacation',
            StartTime: new Date(2018, 1, 12, 10, 0),
            EndTime: new Date(2018, 1, 12, 10, 30),
            IsAllDay: false
        }
    ];
    exports.eventData = [
        {
            Id: 1,
            Subject: 'Explosion of Betelgeuse Star',
            StartTime: new Date(2018, 1, 11, 9, 30),
            EndTime: new Date(2018, 1, 11, 11, 0),
            CategoryColor: '#1aaa55'
        }, {
            Id: 2,
            Subject: 'Thule Air Crash Report',
            StartTime: new Date(2018, 1, 12, 12, 0),
            EndTime: new Date(2018, 1, 12, 14, 0),
            CategoryColor: '#357cd2'
        }, {
            Id: 3,
            Subject: 'Blue Moon Eclipse',
            StartTime: new Date(2018, 1, 13, 9, 30),
            EndTime: new Date(2018, 1, 13, 11, 0),
            CategoryColor: '#7fa900'
        }, {
            Id: 4,
            Subject: 'Meteor Showers in 2018',
            StartTime: new Date(2018, 1, 14, 13, 0),
            EndTime: new Date(2018, 1, 14, 14, 30),
            CategoryColor: '#ea7a57'
        }, {
            Id: 5,
            Subject: 'Milky Way as Melting pot',
            StartTime: new Date(2018, 1, 15, 12, 0),
            EndTime: new Date(2018, 1, 15, 14, 0),
            CategoryColor: '#00bdae'
        }, {
            Id: 6,
            Subject: 'Mysteries of Bermuda Triangle',
            StartTime: new Date(2018, 1, 15, 9, 30),
            EndTime: new Date(2018, 1, 15, 11, 0),
            CategoryColor: '#f57f17'
        }, {
            Id: 7,
            Subject: 'Glaciers and Snowflakes',
            StartTime: new Date(2018, 1, 16, 11, 0),
            EndTime: new Date(2018, 1, 16, 12, 30),
            CategoryColor: '#1aaa55'
        }, {
            Id: 8,
            Subject: 'Life on Mars',
            StartTime: new Date(2018, 1, 17, 9, 0),
            EndTime: new Date(2018, 1, 17, 10, 0),
            CategoryColor: '#357cd2'
        }, {
            Id: 9,
            Subject: 'Alien Civilization',
            StartTime: new Date(2018, 1, 19, 11, 0),
            EndTime: new Date(2018, 1, 19, 13, 0),
            CategoryColor: '#7fa900'
        }, {
            Id: 10,
            Subject: 'Wildlife Galleries',
            StartTime: new Date(2018, 1, 21, 11, 0),
            EndTime: new Date(2018, 1, 21, 13, 0),
            CategoryColor: '#ea7a57'
        }, {
            Id: 11,
            Subject: 'Best Photography 2018',
            StartTime: new Date(2018, 1, 22, 9, 30),
            EndTime: new Date(2018, 1, 22, 11, 0),
            CategoryColor: '#00bdae'
        }, {
            Id: 12,
            Subject: 'Smarter Puppies',
            StartTime: new Date(2018, 1, 9, 10, 0),
            EndTime: new Date(2018, 1, 9, 11, 30),
            CategoryColor: '#f57f17'
        }, {
            Id: 13,
            Subject: 'Myths of Andromeda Galaxy',
            StartTime: new Date(2018, 1, 7, 10, 30),
            EndTime: new Date(2018, 1, 7, 12, 30),
            CategoryColor: '#1aaa55'
        }, {
            Id: 14,
            Subject: 'Aliens vs Humans',
            StartTime: new Date(2018, 1, 5, 10, 0),
            EndTime: new Date(2018, 1, 5, 11, 30),
            CategoryColor: '#357cd2'
        }, {
            Id: 15,
            Subject: 'Facts of Humming Birds',
            StartTime: new Date(2018, 1, 20, 9, 30),
            EndTime: new Date(2018, 1, 20, 11, 0),
            CategoryColor: '#7fa900'
        }, {
            Id: 16,
            Subject: 'Sky Gazers',
            StartTime: new Date(2018, 1, 23, 11, 0),
            EndTime: new Date(2018, 1, 23, 13, 0),
            CategoryColor: '#ea7a57'
        }, {
            Id: 17,
            Subject: 'The Cycle of Seasons',
            StartTime: new Date(2018, 1, 12, 5, 30),
            EndTime: new Date(2018, 1, 12, 7, 30),
            CategoryColor: '#00bdae'
        }, {
            Id: 18,
            Subject: 'Space Galaxies and Planets',
            StartTime: new Date(2018, 1, 12, 17, 0),
            EndTime: new Date(2018, 1, 12, 18, 30),
            CategoryColor: '#f57f17'
        }, {
            Id: 19,
            Subject: 'Lifecycle of Bumblebee',
            StartTime: new Date(2018, 1, 15, 6, 0),
            EndTime: new Date(2018, 1, 15, 7, 30),
            CategoryColor: '#7fa900'
        }, {
            Id: 20,
            Subject: 'Sky Gazers',
            StartTime: new Date(2018, 1, 15, 16, 0),
            EndTime: new Date(2018, 1, 15, 18, 0),
            CategoryColor: '#ea7a57'
        },
        {
            Id: 21,
            Subject: 'Explosion of Betelgeuse Star',
            StartTime: new Date(2018, 0, 11, 9, 30),
            EndTime: new Date(2018, 0, 11, 11, 0),
            CategoryColor: '#1aaa55'
        }, {
            Id: 22,
            Subject: 'Thule Air Crash Report',
            StartTime: new Date(2018, 0, 12, 12, 0),
            EndTime: new Date(2018, 0, 12, 14, 0),
            CategoryColor: '#357cd2'
        }, {
            Id: 23,
            Subject: 'Blue Moon Eclipse',
            StartTime: new Date(2018, 0, 13, 9, 30),
            EndTime: new Date(2018, 0, 13, 11, 0),
            CategoryColor: '#7fa900'
        }, {
            Id: 24,
            Subject: 'Meteor Showers in 2018',
            StartTime: new Date(2018, 0, 14, 13, 0),
            EndTime: new Date(2018, 0, 14, 14, 30),
            CategoryColor: '#ea7a57'
        }, {
            Id: 25,
            Subject: 'Milky Way as Melting pot',
            StartTime: new Date(2018, 0, 15, 12, 0),
            EndTime: new Date(2018, 0, 15, 14, 0),
            CategoryColor: '#00bdae'
        }, {
            Id: 26,
            Subject: 'Mysteries of Bermuda Triangle',
            StartTime: new Date(2018, 0, 15, 9, 30),
            EndTime: new Date(2018, 0, 15, 11, 0),
            CategoryColor: '#f57f17'
        }, {
            Id: 27,
            Subject: 'Glaciers and Snowflakes',
            StartTime: new Date(2018, 0, 16, 11, 0),
            EndTime: new Date(2018, 0, 16, 12, 30),
            CategoryColor: '#1aaa55'
        }, {
            Id: 28,
            Subject: 'Life on Mars',
            StartTime: new Date(2018, 0, 17, 9, 0),
            EndTime: new Date(2018, 0, 17, 10, 0),
            CategoryColor: '#357cd2'
        }, {
            Id: 29,
            Subject: 'Alien Civilization',
            StartTime: new Date(2018, 0, 19, 11, 0),
            EndTime: new Date(2018, 0, 19, 13, 0),
            CategoryColor: '#7fa900'
        }, {
            Id: 30,
            Subject: 'Wildlife Galleries',
            StartTime: new Date(2018, 0, 21, 11, 0),
            EndTime: new Date(2018, 0, 21, 13, 0),
            CategoryColor: '#ea7a57'
        }, {
            Id: 31,
            Subject: 'Best Photography 2018',
            StartTime: new Date(2018, 0, 22, 9, 30),
            EndTime: new Date(2018, 0, 22, 11, 0),
            CategoryColor: '#00bdae'
        }, {
            Id: 32,
            Subject: 'Smarter Puppies',
            StartTime: new Date(2018, 0, 9, 10, 0),
            EndTime: new Date(2018, 0, 9, 11, 30),
            CategoryColor: '#f57f17'
        }, {
            Id: 33,
            Subject: 'Myths of Andromeda Galaxy',
            StartTime: new Date(2018, 0, 7, 10, 30),
            EndTime: new Date(2018, 0, 7, 12, 30),
            CategoryColor: '#1aaa55'
        }, {
            Id: 34,
            Subject: 'Aliens vs Humans',
            StartTime: new Date(2018, 0, 5, 10, 0),
            EndTime: new Date(2018, 0, 5, 11, 30),
            CategoryColor: '#357cd2'
        }, {
            Id: 35,
            Subject: 'Facts of Humming Birds',
            StartTime: new Date(2018, 0, 20, 9, 30),
            EndTime: new Date(2018, 0, 20, 11, 0),
            CategoryColor: '#7fa900'
        }, {
            Id: 36,
            Subject: 'Sky Gazers',
            StartTime: new Date(2018, 0, 23, 11, 0),
            EndTime: new Date(2018, 0, 23, 13, 0),
            CategoryColor: '#ea7a57'
        }, {
            Id: 37,
            Subject: 'The Cycle of Seasons',
            StartTime: new Date(2018, 0, 12, 5, 30),
            EndTime: new Date(2018, 0, 12, 7, 30),
            CategoryColor: '#00bdae'
        }, {
            Id: 38,
            Subject: 'Space Galaxies and Planets',
            StartTime: new Date(2018, 0, 12, 17, 0),
            EndTime: new Date(2018, 0, 12, 18, 30),
            CategoryColor: '#f57f17'
        }, {
            Id: 39,
            Subject: 'Lifecycle of Bumblebee',
            StartTime: new Date(2018, 0, 15, 6, 0),
            EndTime: new Date(2018, 0, 15, 7, 30),
            CategoryColor: '#7fa900'
        }, {
            Id: 40,
            Subject: 'Sky Gazers',
            StartTime: new Date(2018, 0, 15, 16, 0),
            EndTime: new Date(2018, 0, 15, 18, 0),
            CategoryColor: '#ea7a57'
        },
        {
            Id: 41,
            Subject: 'Explosion of Betelgeuse Star',
            StartTime: new Date(2018, 2, 11, 9, 30),
            EndTime: new Date(2018, 2, 11, 11, 0),
            CategoryColor: '#1aaa55'
        }, {
            Id: 42,
            Subject: 'Thule Air Crash Report',
            StartTime: new Date(2018, 2, 12, 12, 0),
            EndTime: new Date(2018, 2, 12, 14, 0),
            CategoryColor: '#357cd2'
        }, {
            Id: 43,
            Subject: 'Blue Moon Eclipse',
            StartTime: new Date(2018, 2, 13, 9, 30),
            EndTime: new Date(2018, 2, 13, 11, 0),
            CategoryColor: '#7fa900'
        }, {
            Id: 44,
            Subject: 'Meteor Showers in 2018',
            StartTime: new Date(2018, 2, 14, 13, 0),
            EndTime: new Date(2018, 2, 14, 14, 30),
            CategoryColor: '#ea7a57'
        }, {
            Id: 45,
            Subject: 'Milky Way as Melting pot',
            StartTime: new Date(2018, 1, 15, 12, 0),
            EndTime: new Date(2018, 1, 15, 14, 0),
            CategoryColor: '#00bdae'
        }, {
            Id: 46,
            Subject: 'Mysteries of Bermuda Triangle',
            StartTime: new Date(2018, 2, 15, 9, 30),
            EndTime: new Date(2018, 2, 15, 11, 0),
            CategoryColor: '#f57f17'
        }, {
            Id: 47,
            Subject: 'Glaciers and Snowflakes',
            StartTime: new Date(2018, 2, 16, 11, 0),
            EndTime: new Date(2018, 2, 16, 12, 30),
            CategoryColor: '#1aaa55'
        }, {
            Id: 48,
            Subject: 'Life on Mars',
            StartTime: new Date(2018, 2, 17, 9, 0),
            EndTime: new Date(2018, 2, 17, 10, 0),
            CategoryColor: '#357cd2'
        }, {
            Id: 49,
            Subject: 'Alien Civilization',
            StartTime: new Date(2018, 2, 19, 11, 0),
            EndTime: new Date(2018, 2, 19, 13, 0),
            CategoryColor: '#7fa900'
        }, {
            Id: 50,
            Subject: 'Wildlife Galleries',
            StartTime: new Date(2018, 2, 21, 11, 0),
            EndTime: new Date(2018, 2, 21, 13, 0),
            CategoryColor: '#ea7a57'
        }, {
            Id: 51,
            Subject: 'Best Photography 2018',
            StartTime: new Date(2018, 2, 22, 9, 30),
            EndTime: new Date(2018, 2, 22, 11, 0),
            CategoryColor: '#00bdae'
        }, {
            Id: 52,
            Subject: 'Smarter Puppies',
            StartTime: new Date(2018, 2, 9, 10, 0),
            EndTime: new Date(2018, 2, 9, 11, 30),
            CategoryColor: '#f57f17'
        }, {
            Id: 53,
            Subject: 'Myths of Andromeda Galaxy',
            StartTime: new Date(2018, 2, 7, 10, 30),
            EndTime: new Date(2018, 2, 7, 12, 30),
            CategoryColor: '#1aaa55'
        }, {
            Id: 54,
            Subject: 'Aliens vs Humans',
            StartTime: new Date(2018, 2, 5, 10, 0),
            EndTime: new Date(2018, 2, 5, 11, 30),
            CategoryColor: '#357cd2'
        }, {
            Id: 55,
            Subject: 'Facts of Humming Birds',
            StartTime: new Date(2018, 2, 20, 9, 30),
            EndTime: new Date(2018, 2, 20, 11, 0),
            CategoryColor: '#7fa900'
        }, {
            Id: 56,
            Subject: 'Sky Gazers',
            StartTime: new Date(2018, 2, 23, 11, 0),
            EndTime: new Date(2018, 2, 23, 13, 0),
            CategoryColor: '#ea7a57'
        }, {
            Id: 57,
            Subject: 'The Cycle of Seasons',
            StartTime: new Date(2018, 2, 12, 5, 30),
            EndTime: new Date(2018, 2, 12, 7, 30),
            CategoryColor: '#00bdae'
        }, {
            Id: 58,
            Subject: 'Space Galaxies and Planets',
            StartTime: new Date(2018, 2, 12, 17, 0),
            EndTime: new Date(2018, 2, 12, 18, 30),
            CategoryColor: '#f57f17'
        }, {
            Id: 59,
            Subject: 'Lifecycle of Bumblebee',
            StartTime: new Date(2018, 2, 15, 6, 0),
            EndTime: new Date(2018, 2, 15, 7, 30),
            CategoryColor: '#7fa900'
        }, {
            Id: 60,
            Subject: 'Sky Gazers',
            StartTime: new Date(2018, 2, 15, 16, 0),
            EndTime: new Date(2018, 2, 15, 18, 0),
            CategoryColor: '#ea7a57'
        }
    ];
});

Explore the live demo at Vue Scheduler example to see Scheduler view customizations in action.

Getting Started with React Scheduler

This section briefly explains how to create React Scheduler and configure its available functionalities in React environment.

Ready to streamline your Syncfusion® React development? Discover the full potential of React components with Syncfusion® AI Coding Assistant. Effortlessly integrate, configure, and enhance your projects with intelligent, context-aware code suggestions, streamlined setups, and real-time insights—all seamlessly integrated into your preferred AI-powered IDEs like VS Code, Cursor, Syncfusion® CodeStudio and more. Explore Syncfusion® AI Coding Assistant

To get started quickly with React Scheduler using the Create React App, you can check on this video

Prerequisites

Install the Syncfusion CLI

Install the Syncfusion CLI globally using the following command:

npm install -g @syncfusion/syncfusion-cli

Set up the Vite project using Syncfusion CLI

You can create a React Vite application using the Syncfusion CLI. The CLI provides two ways to create a project:

Non-interactive mode

Non-interactive mode allows you to create a project directly using a single command with the required command-line arguments.

sf new my-app --framework react --type ts --template scheduler --theme tailwind3

In this mode, the project configuration is passed directly in the command. The above command creates a React Vite application configured with the Syncfusion® Scheduler component.

Interactive mode

Interactive mode guides you through the project creation process with step-by-step prompts.

sf

When you run the sf command, the CLI prompts you to select the required project configuration. To create a React Vite application with the Syncfusion® Scheduler component, select the following options:

√ Project name? ... my-app
√ Choose Framework: » React
√ Choose Build Tool: » Vite
√ Choose Language: » TypeScript
√ Choose Template: » Scheduler
√ Choose Theme: » Tailwind3
√ Choose Style Format: » CSS
√ Would you like to integrate the Syncfusion MCP Server (AI Assistant) into this project? ... no
√ Would you like to install Syncfusion Component Skills for AI-powered development? ... no      
√ Install dependencies and start app now? ... no

The above selections generate a React Vite application configured with the Syncfusion® Scheduler component. You can choose different values for language, theme, style format, MCP setup, and skills installation based on your project requirements.

The Syncfusion® CLI creates the project with a predefined template. After the project is generated, you can customize or replace the component code based on your application requirements.

Run the project

Once the project is created, navigate to the project directory and run the following commands in your terminal.

cd my-app
npm install
npm run dev

The output will appear as follows:

Scheduler Component

Prerequisites

Requirement Version
React 15.5.4 or higher
Node.js 14.0.0 or above
Yarn (optional) 0.25 or above

React supported versions

React version Minimum Syncfusion React Scheduler version  
React v19 29.1.33 and above  
React v18 20.2.36 and above  
React v17 18.3.50 and above  
React v16 16.2.45 and above  

Browser Support

Browser Supported versions
Chrome Latest
Firefox Latest
Opera Latest
Edge 13+
Internet Explorer (IE) 11+
Safari 9+
iOS Safari 9+
Android Browser / Chrome for Android 4.4+
Windows Mobile IE 11+

Installation and configuration

To build a high-performance React application with a smooth development workflow, Vite is the recommended tool. Unlike traditional setups such as Create React App, Vite is designed for speed and simplicity, providing near-instant startup and lightning-fast updates during development. For detailed steps, refer to the Vite installation instructions

Run the following command to set up a React application:

For TypeScript environment:

npm create vite@latest my-app -- --template react-ts

For JavaScript environment:

npm create vite@latest my-app -- --template react

After running the above commands, the project will be created and all required dependencies will be installed automatically.

Adding Syncfusion® Schedule package

All the available Essential® JS 2 packages are published in the npmjs.com public registry. To install the Schedule component, use the following command:

cd my-app
npm install @syncfusion/ej2-react-schedule --save

Adding CSS reference from a theme package

Themes for the Syncfusion® React Schedule component can be applied with CSS files provided through npm theme packages. For a full list of available themes, refer to the Themes documentation. The example below uses the Tailwind 3 theme.

Note: If you are not using Tailwind 3, you can skip the theme-package install and use the default theme CSS shipped with the Schedule component.

Install the Tailwind 3 theme package using the following command:

npm install @syncfusion/ej2-tailwind3-theme --save

Then add the following CSS reference to the src/App.css file:

@import "../node_modules/@syncfusion/ej2-tailwind3-theme/styles/schedule/index.css";

Initialize the Schedule and configure module injection

Import the Schedule component into your src/App.tsx (or src/App.jsx) file and inject the required modules. Since each view in the Schedule is maintained as a separate module, you need to inject the modules required for the desired views.

import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';
import './App.css';

function App () {
  return (
    <ScheduleComponent width="100%" height="550px">
      <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
    </ScheduleComponent>
  );
};

export default App;
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';
import './App.css';

function App () {
  return (
    <ScheduleComponent>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
    </ScheduleComponent>
  );
};

export default App;

Run the following command in the terminal to start the development server. This compiles the project, launches a local server, and allows you to view changes in real time during development.

npm run dev

Open the URL shown in the terminal (typically http://localhost:5173) to view the app.

The demo above will display an empty Schedule.

Setting the current date

The Schedule usually displays the system date as its current date. To change the current date of the Schedule to a specific date, define the selectedDate property.

The Date constructor in JavaScript uses 0-indexed months, so new Date(2026, 4, 18) corresponds to May 18, 2026.

import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';
import './App.css';

function App () {
  return (
    <ScheduleComponent selectedDate={new Date(2026, 4, 18)}>
      <Inject services={[Day, Week, WorkWeek, Agenda, Month]} />
    </ScheduleComponent>
  )
};

export default App;
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';
import './App.css';

function App () {
  return (
    <ScheduleComponent selectedDate={new Date(2026, 4, 18)}>
      <Inject services={[Day, Week, WorkWeek, Agenda, Month]} />
    </ScheduleComponent>
  )
};

export default App;

Setting the current view

Scheduler displays week view by default. To change the current view, define the applicable view name to the currentView property. The default applicable view names are:

  • Day
  • Week
  • WorkWeek
  • Month
  • Agenda
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';
import './App.css';

function App () {
  return (
    <ScheduleComponent currentView='Day'>
      <Inject services={[Day, Week, WorkWeek, Agenda, Month]} />
    </ScheduleComponent>
  )
};

export default App;
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';
import './App.css';

function App () {
  return (
    <ScheduleComponent currentView='Day'>
      <Inject services={[Day, Week, WorkWeek, Agenda, Month]} />
    </ScheduleComponent>
  )
};

export default App;

Populating appointments

To populate the Schedule with appointments, you can use either a local JSON array or a remote data service. Assign the data to the dataSource property, which is part of the eventSettings configuration.

The StartTime and EndTime fields are mandatory for each appointment. The following example uses the default field names: Id, Subject, StartTime, and EndTime.

import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject, type EventSettingsModel } from '@syncfusion/ej2-react-schedule';
import './App.css';

function App () {
  const data = [
    {
      Id: 1,
      Subject: 'Meeting - 1',
      StartTime: new Date(new Date().setHours(9,0,0)),
      EndTime: new Date(new Date().setHours(10,0,0)),
    }
  ];

  const eventSettings: EventSettingsModel = { dataSource: data };

  return (
    <ScheduleComponent eventSettings={eventSettings}>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
    </ScheduleComponent>
  );
};

export default App;
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda, Inject } from '@syncfusion/ej2-react-schedule';
import './App.css';

function App () {
  const data = [
    {
      Id: 1,
      Subject: 'Meeting - 1',
      StartTime: new Date(new Date().setHours(9,0,0)),
      EndTime: new Date(new Date().setHours(10,0,0)),
    }
  ];

  const eventSettings = { dataSource: data };

  return (
    <ScheduleComponent eventSettings={eventSettings}>
      <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
    </ScheduleComponent>
  );
};

export default App;

Troubleshooting

  • The Schedule is not visible — make sure you have set width and height on ScheduleComponent, and that the theme CSS has been imported.
  • A view (Day/Week/WorkWeek/Month/Agenda) is missing — verify the corresponding module is included in the Inject services array.
  • Appointments don’t render — confirm each item in dataSource has valid StartTime and EndTime Date objects.
  • Styles look broken in Vite — prefer importing the theme CSS in src/main.tsx instead of using a relative @import path in App.css.

Version compatibility

Package Minimum version
React 18.0.0
TypeScript (TypeScript workflow only) 4.5
@syncfusion/ej2-react-schedule Latest

See also

Getting Started with Angular Scheduler
This section explains how to create Angular Scheduler and configure its features in an Angular environment.
Ready to streamline your Angular development? Discover the full potential of Angular components with AngularAI Coding Assistant. Effortlessly integrate, configure, and enhance your projects with intelligent, context-aware code suggestions, streamlined setups, and real-time insights—all seamlessly integrated into your preferred AI-powered IDEs like VS Code, Cursor, AngularCodeStudio and more. Explore AngularAI Coding Assistant
For a quick start with the Angular Schedule component using CLI and Schematics, you can watch this video:
Prerequisites
- Node.js 24+ (LTS recommended).
- Syncfusion CLI.
Install the Syncfusion CLI
Install the Syncfusion CLI globally using the following command:
npm install -g @syncfusion/syncfusion-cliCreate a new Angular application using Syncfusion CLI
You can create a Angular application using the Syncfusion CLI. The CLI provides two ways to create a project:
Non-interactive mode
Non-interactive mode allows you to create a project directly using a single command with the required command-line arguments.
sf new syncfusion-angular-app --framework angular --template schedulerIn this mode, the project configuration is passed directly in the command. The above command creates a Angular application configured with the Syncfusion® Schedule component.
Interactive mode
Interactive mode guides you through the project creation process with step-by-step prompts.
sfWhen you run the sf command, the CLI prompts you to select the required project configuration. To create a Angular application with the Syncfusion® Scheduler component, select the following options:
√ Project name? ... syncfusion-angular-app
√ Choose Framework: » Angular
√ Choose Template: » Schedule
√ Choose Theme: » Material3
√ Choose Style Format: » CSS
√ Would you like to integrate the Syncfusion MCP Server (AI Assistant) into this project? ... no
√ Would you like to install Syncfusion Component Skills for AI-powered development? ... no
√ Install dependencies and start app now? ... noThe above selections generate a Angular application configured with the Syncfusion® Scheduler component. You can choose different values for language, theme, style format, MCP setup, and skills installation based on your project requirements.
The Syncfusion® CLI creates the project with a predefined template. After the project is generated, you can customize or replace the component code based on your application requirements.
Run the project
Once the project is created, navigate to the project directory and run the following commands in your terminal.
cd syncfusion-angular-app
npm install
ng serveThe output will appear as follows:

Prerequisites
| Requirement | Version |
|---|---|
| Angular | 12 and above |
| Node.js | 14.0.0 or above, Recommended: Latest Version |
Angular supported versions
| Angular Version | Minimum Syncfusion® Angular Scheduler Version |
|---|---|
| Angular v20 | 29.2.8 |
| Angular v19 | 26.1.35 |
| Angular v18 | 25.2.3 |
| Angular v17 | 23.2.4 |
| Angular v16 | 21.1.39 |
| Angular v15 | 20.4.38 |
| Angular v14 | 20.2.36 |
| Angular v13 | 19.4.38 and above |
| Angular v12 | 19.3.43 |
Browser Support
| Browser | Supported Versions |
|---|---|
| Google Chrome, including Android & iOS | Latest 2 versions |
| Mozilla Firefox | Latest version |
| Microsoft Edge | Latest 2 versions |
| Apple Safari, including iOS | Latest 2 versions |
You can use Angular CLI to set up your Angular applications. To install the Angular CLI, use the following command.
npm install -g @angular/cli
Create an Angular application
Create a new Angular application using the following Angular CLI command.
ng new my-app
This command will prompt you for a few settings for the new project, such as which stylesheet format to use.

By default, it will create a CSS-based application.
Then the CLI also displays an additional prompt whether to enable Server Side Rendering (SSR), and Static Site Generation (SSG) as shown below:

For this setup, when prompted for the Server-side rendering (SSR) option, select No for a standard Angular application.
Then the CLI displays another prompt related to AI tooling support, as shown below:

Any preferred option can be selected based on the development workflow or project needs.
Next, navigate to the project folder:
cd my-app
Installing Schedule package
Angular packages are distributed on npm as @syncfusion scoped packages. To use the Schedule component in your Angular application, install the @syncfusion/ej2-angular-schedule package from npm.
npm install @syncfusion/ej2-angular-schedule --save
Adding CSS reference
Themes for Syncfusion® Schedule components can be applied using CSS files provided through npm theme packages. Available themes include Bootstrap, Fabric, Material, Tailwind 3, and others. For the complete list and comparison, refer to the Themes documentation.
Install the Material 3 theme package using the following command:
npm install @syncfusion/ej2-material3-theme --saveThen add the following CSS reference to the src/style.css file:
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";Initialize the Schedule component and configure module injection
This section explains how to set up the Syncfusion Angular Schedule component in your application by registering the necessary services (such as Day, Week, WorkWeek, Month, and Agenda) in the providers array, and rendering the Scheduler component in the template.
Setting up the component
Replace the contents of src/app/app.ts with the following code:
[src/app/app.ts]
import { Component } from '@angular/core';
import { ScheduleModule, DayService, WeekService, WorkWeekService, MonthService, AgendaService } from '@syncfusion/ej2-angular-schedule';
@Component({
imports: [
ScheduleModule
],
standalone: true,
selector: 'app-root',
providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService],
// Specifies the template string for the Schedule component
template: `<ejs-schedule></ejs-schedule>`
})
export class App { }
Running the development server
Run the following command in the terminal to start the development server. This compiles the project, launches a local server, and allows you to view changes in real-time during development.
ng serve
Note: If
ng servewas already running, restart it to apply the CSS theme changes and component imports.
Verification
Open your browser and navigate to http://localhost:4200/. You should see a blank calendar with the current week displayed and a Tailwind 3 theme applied.
Populating appointments
To populate the Schedule with appointments, you can use either a local JSON array or a remote data service. Assign the data to the dataSource property, which is part of the eventSettings configuration.
The StartTime and EndTime fields are mandatory for each appointment. The following example uses default fields like Id, Subject, StartTime, and EndTime.
[src/app/app.ts]
import { Component } from '@angular/core';
import { ScheduleModule, DayService, WeekService, WorkWeekService, MonthService, AgendaService, EventSettingsModel } from '@syncfusion/ej2-angular-schedule';
@Component({
imports: [
ScheduleModule
],
standalone: true,
selector: 'app-root',
providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService],
// specifies the template string for the Schedule component
template: `<ejs-schedule [eventSettings]='eventSettings'></ejs-schedule>`
})
export class App {
public data: object[] = [{
Id: 1,
Subject: 'Meeting',
StartTime: new Date(new Date().setHours(9, 0, 0)),
EndTime: new Date(new Date().setHours(10, 0, 0))
}];
public eventSettings: EventSettingsModel = {
dataSource: this.data
};
}
Setting the date
By default, the Schedule component displays the current system date. To set a specific date, use the selectedDate property.
[src/app/app.ts]
import { Component } from '@angular/core';
import { ScheduleModule, DayService, WeekService, WorkWeekService, MonthService, AgendaService } from '@syncfusion/ej2-angular-schedule';
@Component({
imports: [
ScheduleModule
],
standalone: true,
selector: 'app-root',
providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService],
// specifies the template string for the Schedule component
template: `<ejs-schedule [selectedDate]='selectedDate'></ejs-schedule>`
})
export class App {
public selectedDate: Date = new Date(2026, 4, 18);
}
Setting the view
The default view of the Schedule is Week. To change the current view, set the currentView property to one of the following default view names:
- Day — Shows a single day with hourly time slots
- Week — Shows a seven-day week with hourly time slots (default)
- WorkWeek — Shows Monday to Friday with hourly time slots
- Month — Shows a full month calendar view
- Agenda — Shows upcoming events in a list format
For detailed information on each view, see Explore available views and their customization options.
import { Component } from '@angular/core';
import { ScheduleModule, DayService, WeekService, WorkWeekService, MonthService, AgendaService, View } from '@syncfusion/ej2-angular-schedule';
@Component({
imports: [
ScheduleModule
],
standalone: true,
selector: 'app-root',
providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService],
// specifies the template string for the Schedule component
template: `<ejs-schedule [currentView]='currentView' ></ejs-schedule>`
})
export class App {
public currentView: View = 'Day';
}